import os
import pyparsing as pp

from s2s_ccg.ccgbank import StaggedReader


# from http://stackoverflow.com/questions/6340351/python-iterating-through-list-of-list
def traverse(o, tree_types=(list, tuple)):
    """ Helper for ccg_extractor, to somewhat efficiently traverse the tree
            
        """
    if isinstance(o, tree_types):
        for value in o:
            for subvalue in traverse(value, tree_types):
                yield subvalue
    else:
        yield o


class CCGBankReader():
    """ Class for reading and processing the original CCGbank files.
    
        Args:
            filepath (str): Path to the directory of CCGbank. Make sure to include last "/" 
            (e.g., "path/to/file/" instead of "path/to/file". This should lead to the _main directory_
            of the CCGbank folder, not any of the subfolders!
            
        Attributes:
            treelike (nested list): A traversible tree-like structure generated with pyparsing.
                        Its processing time is quite long, but might be helpful for future nested evaluation.
            raw (list of strings): Contains the raw AUTO files.
            ccg_tags (list of strings): Contains the ccg tags extracted from the treelike structure.
            
    """

    def __init__(self, filepath):
        self.filepath = filepath
        self.treelike = []
        self.raw = []
        self.ccg_tags = []

    def data_parser(self, sub="data/AUTO/"):
        """ This function is not in use currently, but may be helpful for future projects.
            It will extract a parsed tree structure, containing only the ccg tags.
            
            Args: sub (string): Subdirectory path to the files.
            
        """
        # care for last /, otherwise it doesn't work
        parse_path = self.filepath + sub

        parse_files = []
        parse_list = []

        for path, subdirs, files in os.walk(parse_path):
            temp = [0] * len(files)

            for i in range(len(files)):
                temp[i] = os.path.join(path, files[i])
            temp = sorted(temp)
            temp = [s for s in temp if 'index' not in s]

            # assuming we don't want to add any top-level chapter, or any set
            # which is actually empty:
            if (temp != []):
                # also only add path here, to avoid later conflicts
                parse_list.append(path)
                parse_files.append(temp)

        parse_files = [x for (y, x) in sorted(zip(parse_list, parse_files))]

        # define parser that can detect the brackets and separates accordingly.
        # This already induces a tree-like, traversible structure
        single_value = pp.QuotedString(quoteChar="<", endQuoteChar=">")
        parser = pp.nestedExpr(opener="(", closer=")",
                               content=single_value,
                               ignoreExpr=None)

        parse_data = [0] * len(parse_files)
        unparsed_data = [0] * len(parse_files)
        for i in range(len(parse_files)):
            # preallocation for faster access. doesn't really work, since we can't predict
            # the number of sentences in each file....
            # parse_data[i] = [0] * len(parse_files[i])

            for j, file in enumerate(parse_files[i]):
                with open(file, 'r+') as f:
                    # this really depends how we want to match them later on.

                    # Either by pure sentence number, or indicating a label (e.g. set 0, sent. 4-1)
                    if (j == 0):
                        parse_data[i] = []
                        unparsed_data[i] = []
                    temp = f.readlines()
                    for k in range(1, len(temp), 2):
                        temp2 = temp[k]
                        temp[k] = parser.parseString(temp[k], parseAll=True).asList()
                        parse_data[i].append(temp[k])
                        unparsed_data[i].append(temp2)

        # phew. now we have the raw data
        self.raw = unparsed_data
        self.treelike = parse_data
        # return parse_data, unparsed_data


    def ccg_extractor(self):
        """ parsed data is the tree-like list, generated by data_parser
        
            """
        # preallocation

        parsed_data = self.treelike
        ccg_ground_truth = [0] * len(parsed_data)
        for i in range(len(ccg_ground_truth)):
            ccg_ground_truth[i] = [0] * len(parsed_data[i])

        for i in range(len(parsed_data)):
            for j in range(len(parsed_data[i])):
                runner = 0
                original = self.raw[i][j].split()
                length = len(original)
                temp = list(traverse(parsed_data[i][j]))

                ccg_ground_truth[i][j] = [0] * length
                for k in range(len(temp)):
                    curr = temp[k].split()
                    # making the assumption that only the "words" (or punctuation)
                    # have a longer description with more than 4 values, according to the
                    # documentation...
                    if (len(curr) > 4):
                        ccg_ground_truth[i][j][runner] = curr[1]
                        runner = runner + 1

                    self.ccg_tags = ccg_ground_truth
